#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978

#include <Servo.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

// 初始化液晶螢幕，假設地址為0x27，如果不同請更改
LiquidCrystal_I2C lcd(0x27, 16, 2);

Servo servo_18;
Servo servo_19;
Servo servo_20;
Servo servo_8;

unsigned long startMillis18;
unsigned long startMillis19;
unsigned long startMillis20;
const unsigned long period = 60000;  // 10 seconds in milliseconds
bool timerActive18 = false;
bool timerActive19 = false;
bool timerActive20 = false;
bool countdownActive = false;
bool congratsDisplayed = false;  // 用于检测是否显示 "Congratulation!"
bool timeUpDisplayed = false;    // 用于检测是否显示 "Time's up!"
unsigned long countdownStartMillis;
unsigned long lastBlinkMillis = 0;  // 用于控制 LED 闪烁

void setup() {
  pinMode(12, INPUT_PULLUP);  // 按鈕
  pinMode(4, INPUT);          // D4 紅外線感測器
  pinMode(5, INPUT);          // D5 紅外線感測器
  pinMode(7, INPUT);          // D7 紅外線感測器
  pinMode(10, OUTPUT);        // D10 LED
  pinMode(11, OUTPUT);        // D11 LED
  pinMode(9, OUTPUT);         // 蜂鳴器

  // 設定伺服馬達
  servo_18.attach(18);
  servo_19.attach(19);
  servo_20.attach(20);
  servo_8.attach(8);
  servo_8.write(1);  // D8 起始角度為 1 度

  // 初始化液晶螢幕
  lcd.init();
  lcd.backlight();
  lcd.clear();
}

void loop() {
  // 按鈕被按下
  if (digitalRead(12) == LOW) {
    // 重置 LED 狀態
    digitalWrite(10, LOW);
    digitalWrite(11, LOW);
    congratsDisplayed = false;
    timeUpDisplayed = false;

    int A = random(1, 4);

    // 清除倒數計時並重置液晶螢幕
    lcd.clear();
    countdownActive = false;

    switch (A) {
      case 1:
        tone(13, 131);
        delay(100);
        noTone(13);
        servo_18.write(179);
        delay(1000);
        servo_18.write(90);
        delay(500);
        timerActive18 = true;
        startMillis18 = millis();
        break;

      case 2:
        tone(13, 131);
        delay(100);
        noTone(13);
        servo_19.write(179);
        delay(1000);
        servo_19.write(90);
        delay(500);
        timerActive19 = true;
        startMillis19 = millis();
        break;

      case 3:
        tone(13, 131);
        delay(100);
        noTone(13);
        servo_20.write(179);
        delay(1000);
        servo_20.write(90);
        delay(500);
        timerActive20 = true;
        startMillis20 = millis();
        break;
    }

    // 啟動倒數計時
    countdownActive = true;
    countdownStartMillis = millis();
  }

  // 檢查紅外線感測器
  unsigned long currentMillis = millis();

  if (timerActive18 && currentMillis - startMillis18 < period) {
    if (digitalRead(4) == LOW) {  // D4 感測到物體
      moveServo8();
      timerActive18 = false;
    }
  }

  if (timerActive19 && currentMillis - startMillis19 < period) {
    if (digitalRead(5) == LOW) {  // D5 感測到物體
      moveServo8();
      timerActive19 = false;
    }
  }

  if (timerActive20 && currentMillis - startMillis20 < period) {
    if (digitalRead(7) == LOW) {  // D7 感測到物體
      moveServo8();
      timerActive20 = false;
    }
  }

  // 更新倒數計時顯示
  if (countdownActive) {
    unsigned long elapsedMillis = currentMillis - countdownStartMillis;
    if (elapsedMillis < period) {
      unsigned long remainingMillis = period - elapsedMillis;
      unsigned long seconds = (remainingMillis / 1000) % 60;
      unsigned long minutes = (remainingMillis / 1000) / 60;
      lcd.setCursor(0, 0);
      lcd.print("Time left: ");
      lcd.setCursor(0, 1);
      lcd.print(minutes);
      lcd.print(":");
      if (seconds < 10) {
        lcd.print("0");
      }
      lcd.print(seconds);
    } else {
      countdownActive = false;
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Time's up!");
      timeUpDisplayed = true;  // 设置 timeUpDisplayed 标志
      digitalWrite(11, HIGH);  // D11 LED 恆亮
      playSadSound();          // 播放伤心的音效
    }
  }

  // 控制 D10 LED 快速閃爍
  if (congratsDisplayed) {
    if (currentMillis - lastBlinkMillis >= 250) {  // 每 250 毫秒閃爍一次
      digitalWrite(10, !digitalRead(10));          // 切換 LED 狀態
      lastBlinkMillis = currentMillis;
    }
  }

  // 如果 time's up，保持 D11 LED 恆亮直到重新開始
  if (timeUpDisplayed && !countdownActive) {
    digitalWrite(11, HIGH);
  }
}

void moveServo8() {
  // 當伺服馬達轉動時停止倒數計時並顯示 Congratulation!
  countdownActive = false;
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Congratulation!");
  congratsDisplayed = true;  // 设置 congratsDisplayed 标志

  servo_8.write(45);
  delay(350);
  servo_8.write(1);
  playMarioWinSound();  // 播放马里奥通关音效
}

void playMarioWinSound() {
  // 马里奥通关音效
  int melody[] = {
    NOTE_E7, NOTE_E7, 0, NOTE_E7,
    0, NOTE_C7, NOTE_E7, 0,
    NOTE_G7, 0, 0,  0,
    NOTE_G6, 0, 0, 0,

    NOTE_C7, 0, 0, NOTE_G6,
    0, 0, NOTE_E6, 0,
    0, NOTE_A6, 0, NOTE_B6,
    0, NOTE_AS6, NOTE_A6, 0,

    NOTE_G6, NOTE_E7, NOTE_G7,
    NOTE_A7, 0, NOTE_F7, NOTE_G7,
    0, NOTE_E7, 0, NOTE_C7,
    NOTE_D7, NOTE_B6, 0, 0
  };

  int noteDurations[] = {
    12, 12, 12, 12,
    12, 12, 12, 12,
    12, 12, 12, 12,
    12, 12, 12, 12,

    12, 12, 12, 12,
    12, 12, 12, 12,
    12, 12, 12, 12,
    12, 12, 12, 12,

    9, 9, 9, 12,
    12, 12, 12, 12,
    12, 12, 12, 12,
    12, 12, 12, 12
  };

  for (int thisNote = 0; thisNote < sizeof(melody) / sizeof(int); thisNote++) {
    int noteDuration = 1000 / noteDurations[thisNote];
    tone(9, melody[thisNote], noteDuration);
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    noTone(9);
  }
}

void playSadSound() {
  // 伤心的音效
  int melody[] = {
    NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4
  };

  int noteDurations[] = {
    4, 8, 8, 4, 4, 4, 4, 4
  };

  for (int thisNote = 0; thisNote < sizeof(melody) / sizeof(int); thisNote++) {
    int noteDuration = 1000 / noteDurations[thisNote];
    tone(9, melody[thisNote], noteDuration);
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    noTone(9);
  }
}
